function load() {
	// track has ended
	document.getElementById('player').addEventListener('ended', function() {
		// shuffle
		if (document.getElementById('shuffle').checked) {
			var httpRequest;
			httpRequest = new XMLHttpRequest();
			httpRequest.onreadystatechange = function () {
				if (httpRequest.readyState !== XMLHttpRequest.DONE) { return; }
				if (httpRequest.status !== 200) { return; }

				let track = JSON.parse(httpRequest.responseText);
				change_track(track);
			};
			httpRequest.open('GET', api_uri + '/random', true);
			httpRequest.send();
		}
	});
}

function select_artist(select) {
	var httpRequest;
	httpRequest = new XMLHttpRequest();
	httpRequest.onreadystatechange = function () {
		if (httpRequest.readyState !== XMLHttpRequest.DONE) { return; }
		if (httpRequest.status !== 200) { return; }
		nav_items = JSON.parse(httpRequest.responseText);
		let html_str = '';
		for (let i = 0; i < nav_items.length; i++) {
			html_str += '<option value="' + nav_items[i] + '">' + nav_items[i] + '</option>';
		}
		document.getElementById('albumList').innerHTML = html_str;
		document.getElementById('trackList').innerHTML = '';
	};
	let params = {
		artist: select.value,
	};
	let query = Object.keys(params)
		.map(k => encodeURIComponent(k) + '=' + encodeURIComponent(params[k]))
		.join('&');
	httpRequest.open('GET', api_uri + '?' + query, true);
	httpRequest.send();
}

function select_album(select) {
	var httpRequest;
	httpRequest = new XMLHttpRequest();
	httpRequest.onreadystatechange = function () {
		if (httpRequest.readyState !== XMLHttpRequest.DONE) { return; }
		if (httpRequest.status !== 200) { return; }
		nav_items = JSON.parse(httpRequest.responseText);
		let html_str = '';
		for (let i = 0; i < nav_items.length; i++) {
			html_str += '<option data-discnumber="' + nav_items[i][0] + '" data-tracknumber="' + nav_items[i][1]+ '" value="' + nav_items[i][2] + '">' + nav_items[i][0] + '.' + nav_items[i][1] + ' - ' + nav_items[i][2] + '</option>';
		}
		document.getElementById('trackList').innerHTML = html_str;
	};
	let params = {
		artist: document.getElementById('artistList').value,
		album: select.value,
	};
	let query = Object.keys(params)
		.map(k => encodeURIComponent(k) + '=' + encodeURIComponent(params[k]))
		.join('&');
	httpRequest.open('GET', api_uri + '?' + query, true);
	httpRequest.send();
}

function select_track(select) {
	var httpRequest;
	httpRequest = new XMLHttpRequest();
	httpRequest.onreadystatechange = function () {
		if (httpRequest.readyState !== XMLHttpRequest.DONE) { return; }
		if (httpRequest.status !== 200) { return; }

		let track = JSON.parse(httpRequest.responseText);
		change_track(track);
	};
	let params = {
		artist: document.getElementById('artistList').value,
		album: document.getElementById('albumList').value,
		discnumber: select.selectedOptions[0].dataset.discnumber,
		tracknumber: select.selectedOptions[0].dataset.tracknumber,
	};
	let query = Object.keys(params)
		.map(k => encodeURIComponent(k) + '=' + encodeURIComponent(params[k]))
		.join('&');
	httpRequest.open('GET', api_uri + '?' + query, true);
	httpRequest.send();
}

function change_track(track) {
	let params = {
		artist: track.artist,
		album: track.album,
		discnumber: track.discnumber,
		tracknumber: track.tracknumber,
	};
	let query = Object.keys(params)
		.map(k => encodeURIComponent(k) + '=' + encodeURIComponent(params[k]))
		.join('&');

	let source = document.getElementById('stream');
	source.src = document.location.href + '/stream?' + query;
	let player = document.getElementById('player');
	player.load();
	player.play();
	document.getElementById('nowPlayingArtist').innerHTML = track.artist;
	document.getElementById('nowPlayingAlbum').innerHTML = track.album;
	document.getElementById('nowPlayingTitle').innerHTML = track.title;

	document.getElementById('albumCover').firstChild.src = document.location.href + '/coverart?' + query;
}
